package com.company.kanbantest.entity;

import io.jmix.core.metamodel.datatype.EnumClass;

import org.springframework.lang.Nullable;


public enum BillingIncompleteStatus implements EnumClass<String> {

    QUEUE("queue"),
    ATTEMPTED("attempted"),
    CONTACTED("contacted");

    private final String id;

    BillingIncompleteStatus(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    @Nullable
    public static BillingIncompleteStatus fromId(String id) {
        for (BillingIncompleteStatus at : BillingIncompleteStatus.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }
}