package com.company.kanbantest.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.data.DdlGeneration;
import jakarta.persistence.*;

import java.math.BigDecimal;
import java.util.Date;
import java.util.UUID;

@DdlGeneration(value = DdlGeneration.DbScriptGenerationMode.DISABLED,
        unmappedColumns = {"a1_hour_approval", "a1_signature_approval", "a1_location_approval", "a2_hour_approval", "a2_signature_approval", "a2_location_approval", "submission_status"})
@JmixEntity
@Table(name = "billing_shifts")
@Entity
public class BillingShift {
    @JmixGeneratedValue
    @Column(name = "uuid", nullable = false)
    @Id
    private UUID id;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "a1_hour_approval_timestamp")
    private Date a1HourApprovalTimestamp;

    @JoinColumn(name = "a1_hour_approval_user")
    @ManyToOne(fetch = FetchType.LAZY)
    private User a1HourApprovalUser;

    @Column(name = "a1_notes")
    private String a1Notes;

    @Column(name = "a1_watch")
    private Boolean a1Watch;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "a2_hour_approval_timestamp")
    private Date a2HourApprovalTimestamp;

    @JoinColumn(name = "a2_hour_approval_user")
    @ManyToOne(fetch = FetchType.LAZY)
    private User a2HourApprovalUser;

    @Column(name = "a2_notes")
    private String a2Notes;

    @Column(name = "a2_watch")
    private Boolean a2Watch;

    @Column(name = "paper_time", nullable = false)
    private Boolean paperTime = false;

    @Column(name = "temporary_assignment", nullable = false)
    private Boolean temporaryAssignment = false;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "watch_resolved_at")
    private Date watchResolvedAt;

    @JoinColumn(name = "watch_resolved_by")
    @ManyToOne(fetch = FetchType.LAZY)
    private User watchResolvedBy;

    @Column(name = "weekly_hours_approved", nullable = false, precision = 4, scale = 2)
    private BigDecimal weeklyHoursApproved;

    @Column(name = "a1_hour_approval")
    private String a1HourApproval;

    @Column(name = "a1_location_approval")
    private String a1LocationApproval;

    @Column(name = "a1_signature_approval")
    private String a1SignatureApproval;

    @Column(name = "a2_hour_approval")
    private String a2HourApproval;

    @Column(name = "a2_location_approval")
    private String a2LocationApproval;

    @Column(name = "a2_signature_approval")
    private String a2SignatureApproval;

    @InstanceName
    @Column(name = "submission_status")
    private String submissionStatus;

    @Column(name = "incomplete_status")
    private String incompleteStatus;

    public BillingIncompleteStatus getIncompleteStatus() {
        return incompleteStatus == null ? null : BillingIncompleteStatus.fromId(incompleteStatus);
    }

    public void setIncompleteStatus(BillingIncompleteStatus incompleteStatus) {
        this.incompleteStatus = incompleteStatus == null ? null : incompleteStatus.getId();
    }

    public BillSubmissionEnum getSubmissionStatus() {
        return submissionStatus == null ? null : BillSubmissionEnum.fromId(submissionStatus);
    }

    public void setSubmissionStatus(BillSubmissionEnum submissionStatus) {
        this.submissionStatus = submissionStatus == null ? null : submissionStatus.getId();
    }

    public BillingStatusEnum getA2SignatureApproval() {
        return a2SignatureApproval == null ? null : BillingStatusEnum.fromId(a2SignatureApproval);
    }

    public void setA2SignatureApproval(BillingStatusEnum a2SignatureApproval) {
        this.a2SignatureApproval = a2SignatureApproval == null ? null : a2SignatureApproval.getId();
    }

    public BillingStatusEnum getA2LocationApproval() {
        return a2LocationApproval == null ? null : BillingStatusEnum.fromId(a2LocationApproval);
    }

    public void setA2LocationApproval(BillingStatusEnum a2LocationApproval) {
        this.a2LocationApproval = a2LocationApproval == null ? null : a2LocationApproval.getId();
    }

    public BillingStatusEnum getA2HourApproval() {
        return a2HourApproval == null ? null : BillingStatusEnum.fromId(a2HourApproval);
    }

    public void setA2HourApproval(BillingStatusEnum a2HourApproval) {
        this.a2HourApproval = a2HourApproval == null ? null : a2HourApproval.getId();
    }

    public BillingStatusEnum getA1SignatureApproval() {
        return a1SignatureApproval == null ? null : BillingStatusEnum.fromId(a1SignatureApproval);
    }

    public void setA1SignatureApproval(BillingStatusEnum a1SignatureApproval) {
        this.a1SignatureApproval = a1SignatureApproval == null ? null : a1SignatureApproval.getId();
    }

    public BillingStatusEnum getA1LocationApproval() {
        return a1LocationApproval == null ? null : BillingStatusEnum.fromId(a1LocationApproval);
    }

    public void setA1LocationApproval(BillingStatusEnum a1LocationApproval) {
        this.a1LocationApproval = a1LocationApproval == null ? null : a1LocationApproval.getId();
    }

    public BillingStatusEnum getA1HourApproval() {
        return a1HourApproval == null ? null : BillingStatusEnum.fromId(a1HourApproval);
    }

    public void setA1HourApproval(BillingStatusEnum a1HourApproval) {
        this.a1HourApproval = a1HourApproval == null ? null : a1HourApproval.getId();
    }

    public BigDecimal getWeeklyHoursApproved() {
        return weeklyHoursApproved;
    }

    public void setWeeklyHoursApproved(BigDecimal weeklyHoursApproved) {
        this.weeklyHoursApproved = weeklyHoursApproved;
    }

    public User getWatchResolvedBy() {
        return watchResolvedBy;
    }

    public void setWatchResolvedBy(User watchResolvedBy) {
        this.watchResolvedBy = watchResolvedBy;
    }

    public Date getWatchResolvedAt() {
        return watchResolvedAt;
    }

    public void setWatchResolvedAt(Date watchResolvedAt) {
        this.watchResolvedAt = watchResolvedAt;
    }

    public Boolean getTemporaryAssignment() {
        return temporaryAssignment;
    }

    public void setTemporaryAssignment(Boolean temporaryAssignment) {
        this.temporaryAssignment = temporaryAssignment;
    }

    public Boolean getPaperTime() {
        return paperTime;
    }

    public void setPaperTime(Boolean paperTime) {
        this.paperTime = paperTime;
    }

    public Boolean getA2Watch() {
        return a2Watch;
    }

    public void setA2Watch(Boolean a2Watch) {
        this.a2Watch = a2Watch;
    }

    public String getA2Notes() {
        return a2Notes;
    }

    public void setA2Notes(String a2Notes) {
        this.a2Notes = a2Notes;
    }

    public User getA2HourApprovalUser() {
        return a2HourApprovalUser;
    }

    public void setA2HourApprovalUser(User a2HourApprovalUser) {
        this.a2HourApprovalUser = a2HourApprovalUser;
    }

    public Date getA2HourApprovalTimestamp() {
        return a2HourApprovalTimestamp;
    }

    public void setA2HourApprovalTimestamp(Date a2HourApprovalTimestamp) {
        this.a2HourApprovalTimestamp = a2HourApprovalTimestamp;
    }

    public Boolean getA1Watch() {
        return a1Watch;
    }

    public void setA1Watch(Boolean a1Watch) {
        this.a1Watch = a1Watch;
    }

    public String getA1Notes() {
        return a1Notes;
    }

    public void setA1Notes(String a1Notes) {
        this.a1Notes = a1Notes;
    }

    public User getA1HourApprovalUser() {
        return a1HourApprovalUser;
    }

    public void setA1HourApprovalUser(User a1HourApprovalUser) {
        this.a1HourApprovalUser = a1HourApprovalUser;
    }

    public Date getA1HourApprovalTimestamp() {
        return a1HourApprovalTimestamp;
    }

    public void setA1HourApprovalTimestamp(Date a1HourApprovalTimestamp) {
        this.a1HourApprovalTimestamp = a1HourApprovalTimestamp;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}