package com.company.kanbantest.hotfix;

import io.jmix.kanbanflowui.component.loader.KanbanLoader;
import io.jmix.kanbanflowui.kit.component.JmixKanban;

public class FixedKanbanLoader extends KanbanLoader {

    @Override
    public void loadComponent() {
        loadBoolean(element, "columnReorderingAllowed", resultComponent::setColumnReorderingAllowed);
        loadBoolean(element, "columnHidingAllowed", resultComponent::setColumnHidingAllowed);

        loadBoolean(element, "dragAllowed", resultComponent::setDragAllowed);
        loadBoolean(element, "dropAllowed", resultComponent::setDropAllowed);
        loadBoolean(element, "dropPlaceholderAllowed", resultComponent::setDropPlaceholderAllowed);

        loadBoolean(element, "applyColumnColorToTasks", resultComponent::setApplyColumnColorToTasksEnabled);
        loadBoolean(element, "autoColumnHeightEnabled", resultComponent::setAutoColumnHeightEnabled);

        loadBoolean(element, "collapsible", resultComponent::setCollapsible);

        loadInteger(element, "columnsWidth", resultComponent::setColumnsWidth);
        loadBoolean(element, "columnColorEntireSurfaceEnabled", resultComponent::setColumnColorEntireSurfaceEnabled);
        loadBoolean(element, "columnFooterVisible", resultComponent::setColumnFooterVisible);
        loadBoolean(element, "columnActionsEnabled", resultComponent::setColumnActionsEnabled);
        loadBoolean(element, "columnSummaryEnabled", resultComponent::setColumnSummaryEnabled);

        loadEnum(element, JmixKanban.HierarchyMode.class, "hierarchyMode", resultComponent::setHierarchyMode);

        loadInteger(element, "swimlanesFrom", resultComponent::setSwimlanesFrom);
        loadInteger(element, "swimlanesTo", resultComponent::setSwimlanesTo);

        loadBoolean(element, "taskDueDateVisible", resultComponent::setTaskDueDateVisible);
        loadBoolean(element, "taskUserAvatarVisible", resultComponent::setTaskUserAvatarVisible);
        loadEnum(element, JmixKanban.TaskPosition.class, "taskPosition", resultComponent::setTaskPosition);
        loadBoolean(element, "taskPriorityVisible", resultComponent::setTaskPriorityVisible);
        loadBoolean(element, "taskProgressVisible", resultComponent::setTaskProgressVisible);
        loadBoolean(element, "taskColorEntireSurfaceEnabled", resultComponent::setTaskColorEntireSurfaceEnabled);
        loadBoolean(element, "taskTagsVisible", resultComponent::setTaskTagsVisible);
        loadBoolean(element, "autoSave", this::initAutoSave);

        loadJsFunction(element, "columnHeaderRendererFunction", resultComponent::setColumnHeaderRendererFunction);
        loadJsFunction(element, "columnFooterRendererFunction", resultComponent::setColumnFooterRendererFunction);
        loadJsFunction(element, "taskRendererFunction", resultComponent::setTaskRendererFunction);

        componentLoader().loadSizeAttributes(resultComponent, element);
        componentLoader().loadEnabled(resultComponent, element);
        componentLoader().loadClassNames(resultComponent, element);

        loadColumns();
        loadSwimlanes();
        loadPropertiesMapping();
        loadData();
        loadActions();
    }
}
